/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.battle.BattleField
 *  fire.pb.battle.DemoResult
 *  fire.pb.battle.Fighter
 *  fire.pb.battle.ResultItem
 *  fire.pb.battle.SubResultItem
 *  xbean.BattleInfo
 *  xbean.Protectors
 */
package fire.pb.option;

import fire.pb.battle.BattleField;
import fire.pb.battle.DemoResult;
import fire.pb.battle.Fighter;
import fire.pb.battle.ResultItem;
import fire.pb.battle.SubResultItem;
import java.util.LinkedList;
import java.util.List;
import xbean.BattleInfo;
import xbean.Protectors;

public abstract class BasicOperation {
    protected boolean isFailed = false;
    protected int failreason = 0;
    protected ResultItem resultItem = new ResultItem();
    private final BattleInfo battle;
    private final int operator;
    private int aim;
    protected final Fighter opfighter;
    public static final int FAIL_HP_NOT_ENOUGH = 141164;
    public static final int FAIL_MP_NOT_ENOUGH = 141165;
    public static final int FAIL_SP_NOT_ENOUGH = 141166;
    public static final int FAIL_EP_NOT_ENOUGH = 160001;
    public static final int FAIL_HP_NOT_ENOUGH_WARRIOR = 160004;
    public static final int FAIL_ZITAI_XIULUO = 141167;
    public static final int FAIL_ZITAI_LUOSHA = 141168;
    public static final int FAIL_ZITAI_JINGANG = 141170;
    public static final int FAIL_CATCH_PET = 141173;
    public static final int FAIL_SUMMON_PET = 141185;
    public static final int FAIL_FETCH_PET = 141186;
    public static final int FAIL_CANNOT_ACTION = 141178;
    public static final int FAIL_ITEM_AIM = 141179;
    public static final int FAIL_SKILL_AIM = 141180;
    public static final int FAIL_ZITAI = 141181;
    public static final int FAIL_NO_AIM = 141182;
    public static final int FAIL_ITEM_TO_DEATH = 142494;
    public static final int FAIL_PET_MP_NOT_ENOUGH = 141506;
    public static final int FAIL_SOMMON_NO_POS = 160600;
    public static final int FAIL_CANNOT_RELIVE_WITH_DIE_FORBID = 162003;

    BasicOperation(BattleInfo battle, int operator, int aim) {
        this.battle = battle;
        this.operator = operator;
        this.aim = aim;
        this.opfighter = operator == 0 ? battle.getFieldfighter() : (Fighter)battle.getFighterobjects().get(operator);
    }

    public abstract int getType();

    public abstract int getResultType();

    public abstract int getOperateID();

    public abstract boolean canChangeAim();

    public final BattleInfo getBattle() {
        return this.battle;
    }

    public final int getOperator() {
        return this.operator;
    }

    public final int getAim() {
        return this.aim;
    }

    public final void setAim(int aim) {
        this.aim = aim;
    }

    public void process() {
        this.battle.getRoundresult().put(this.getAim(), this.getResultType());
    }

    public int getHPconsume() {
        return 0;
    }

    public int getMPconsume() {
        return 0;
    }

    public int getSPconsume() {
        return 0;
    }

    public LinkedList<DemoResult> getDemoResult() {
        LinkedList<DemoResult> list = new LinkedList<DemoResult>();
        DemoResult r = new DemoResult();
        r.targetid = this.getAim();
        r.targetresult = this.getResultType();
        list.add(r);
        return list;
    }

    public LinkedList<SubResultItem> getSubResult() {
        LinkedList<SubResultItem> list = new LinkedList<SubResultItem>();
        SubResultItem r = new SubResultItem();
        r.resultlist.addAll(this.getDemoResult());
        list.add(r);
        return list;
    }

    public boolean checkOperator() {
        if (!this.battle.getFighters().containsKey(this.getOperator())) {
            return false;
        }
        if (BattleField.checkOutBattle((BattleInfo)this.battle, (int)this.operator)) {
            return false;
        }
        if (this.opfighter == null) {
            return false;
        }
        return this.opfighter.canAction(this.getType(), this.getOperateID());
    }

    protected boolean checkAndChangeAim() {
        if (this.checkAim()) {
            return true;
        }
        if (!this.canChangeAim()) {
            return false;
        }
        this.setAim(0);
        return true;
    }

    protected List<Integer> getAims() {
        return BattleField.getEnemies((BattleInfo)this.battle, (int)this.getOperator());
    }

    protected boolean checkAim() {
        if (!this.battle.getFighters().containsKey(this.getAim())) {
            return false;
        }
        if (BattleField.checkOutBattle((BattleInfo)this.battle, (int)this.getAim())) {
            return false;
        }
        Fighter fighter = (Fighter)this.battle.getFighterobjects().get(this.aim);
        if (fighter == null || !fighter.canBeAction(this.getType())) {
            return false;
        }
        return this.checkHidden();
    }

    public ResultItem getResultItem() {
        if (this.resultItem != null) {
            this.resultItem.execute.attackerid = this.operator;
            this.resultItem.execute.hpconsume = this.getHPconsume();
            this.resultItem.execute.mpconsume = this.getMPconsume();
            if (this.resultItem.execute.operationtype == 14 || this.resultItem.execute.operationtype == 20) {
                return this.resultItem;
            }
            this.resultItem.execute.operationtype = this.getType();
            this.resultItem.execute.operationid = this.getOperateID();
            this.processActiveHidden();
            this.resultItem.subresultlist = this.getSubResult();
        }
        return this.resultItem;
    }

    public boolean checkEffective() {
        if (!this.checkOperator()) {
            return false;
        }
        return this.checkAndChangeAim();
    }

    public final List<Integer> getProtectors(int index) {
        Protectors ps = (Protectors)this.battle.getProtectormap().get(index);
        return null == ps ? new LinkedList() : ps.getProtectorlist();
    }

    protected boolean checkHidden() {
        Fighter aimfighter = (Fighter)this.battle.getFighterobjects().get(this.aim);
        if (aimfighter == null) {
            return false;
        }
        if (!(aimfighter.getBuffAgent().existBuff(509082) || aimfighter.getBuffAgent().existBuff(509083) || aimfighter.getBuffAgent().existBuff(506201))) {
            return true;
        }
        return this.opfighter.getBuffAgent().existBuff(509032) || this.opfighter.getBuffAgent().existBuff(509069) || this.opfighter.getBuffAgent().existBuff(504010);
    }

    protected void processActiveHidden() {
    }

    public int getProtectorResult(int proIndex) {
        return 0;
    }
}

